<template>
  <div class="outer-box" :style="{ gridColumnEnd: `span ${size}` }">
    <h3 v-if="name != null">
      {{ name }} <span v-if="error != null" class="error">{{ error }}</span>
    </h3>
    <div
      :class="['generic', { input_box: styled }]"
      tabindex="-1"
      v-on:focus.stop="$emit('model-focus')"
      v-on:blur.stop="$emit('model-blur')"
    >
      <slot></slot>
    </div>
  </div>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";

@Options({
  props: {
    name: {
      type: String,
      required: false,
    },
    size: {
      type: String,
      default: "1",
    },
    error: {
      type: String,
      required: false,
    },
    styled: {
      type: Boolean,
      default: true,
    },
  },
  emits: ["model-focus", "model-blur"],
})
export default class InputBase extends Vue {
  public name?: string;
  public error?: string;

  public size!: string;
  public styled!: boolean;
}
</script>

<style scoped lang="scss">
@import "@/styles/globals";

.outer-box {
  position: relative;

  h3 {
    text-align: left;
    font-size: 16px;
    font-weight: bold;
    color: $black_text;
    margin: 0;
    margin-bottom: 10px;

    .error {
      color: $red;
      font-size: 10px;
    }
  }

  .input_box {
    box-shadow: 0 0 3px 0 $shadow_grey;
    background-color: white;
    color: $black_text;
  }

  .generic {
    display: flex;
    width: 100%;
    min-height: 40px;
    outline: none;
    position: relative;
  }
}
</style>
